



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PTA Insert or Merge</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PTA Insert or Merge</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 11:02:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>According to Wikipedia:</p>
<p><strong>Insertion sort</strong>&nbsp;iterates, consuming one input element each repetition, and growing a sorted output list. Each iteration, insertion sort removes one element from the input data, finds the location it belongs within the sorted list, and inserts it there. It repeats until no input elements remain.</p>
<p><strong>Merge sort</strong>&nbsp;works as follows: Divide the unsorted list into N sublists, each containing 1 element (a list of 1 element is considered sorted). Then repeatedly merge two adjacent sublists to produce new sorted sublists until there is only 1 sublist remaining.</p>
<p>Now given the initial sequence of integers, together with a sequence which is a result of several iterations of some sorting method, can you tell which sorting method we are using?</p>
<h3>Input Specification:</h3>
<p>Each input file contains one test case. For each case, the first line gives a positive integer&nbsp;NN&nbsp;(\le 100≤100). Then in the next line,&nbsp;NN&nbsp;integers are given as the initial sequence. The last line contains the partially sorted sequence of the&nbsp;NN&nbsp;numbers. It is assumed that the target sequence is always ascending. All the numbers in a line are separated by a space.</p>
<h3>Output Specification:</h3>
<p>For each test case, print in the first line either "Insertion Sort" or "Merge Sort" to indicate the method used to obtain the partial result. Then run this method for one more iteration and output in the second line the resuling sequence. It is guaranteed that the answer is unique for each test case. All the numbers in a line must be separated by a space, and there must be no extra space at the end of the line.</p>
<h3>Sample Input 1:</h3>
<pre class="prettyprint linenums"><code>10
3 1 2 8 7 5 9 4 6 0
1 2 3 7 8 5 9 4 6 0
</code></pre>
<h3>Sample Output 1:</h3>
<pre class="prettyprint linenums"><code>Insertion Sort
1 2 3 5 7 8 9 4 6 0
</code></pre>
<h3>Sample Input 2:</h3>
<pre class="prettyprint linenums"><code>10
3 1 2 8 7 5 9 4 0 6
1 3 2 8 5 7 4 9 0 6
</code></pre>
<h3>Sample Output 2:</h3>
<pre class="prettyprint linenums"><code>Merge Sort</code></pre>
<p><strong>解答</strong></p>
<p>这题目就是先用插入排序去尝试，每插入一次就比较与题目中的数组是否相等，如果相等的话就再进行一次插入然后输出（用flag变量来控制，相等就置为true，每一次插入后检查flag为true就跳出循环），如果全部排序完成还没有相等的，就说明是归并排序，这里隐含条件是用迭代的归并排序，同样每一次都与题中数组比较，相等后就再归并一次。</p>
<div>
<pre class="prettyprint linenums">//
//  main.c
//  Insert or Merge
//
//  Created by 余南龙 on 2016/12/9.
//  Copyright © 2016年 余南龙. All rights reserved.
//

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#define true 1
#define false 0
#define MAX 101

int comp(const void *a, const void *b){
    return *(int*)a - *(int*)b;
}

void Init(int initial[], int tmp[], int partial[], int *N){
    int i, tmp_val;

    scanf("%d", N);
    tmp_val = *N;
    ; i &lt; tmp_val; i++){
        scanf("%d", initial + i);
        tmp[i] = initial[i];
    }
    ; i &lt; tmp_val; i++){
        scanf("%d", partial + i);
    }
}

void Output(int a[], int size){
    int i;

    ; i &lt; size; i++) {
         == i) {
            printf("%d", a[i]);
        }
        else{
            printf(" %d", a[i]);
        }
    }
}

int Is_Equal(int a[], int b[], int size){
    int i;

    ; i &lt; size; i++){
        if(a[i] != b[i]){
            return false;
        }
    }
    return true;
}

int Is_Insertion_Sort(int initial[], int partial[], int size){
    ;

    ; i &lt; size; i++){
        tmp = initial[i];
        ; j &gt;= ; j--){
            if(initial[j] &gt; tmp){
                initial[j + ] = initial[j];
            }
            else{
                break;
            }
        }
        initial[j + ] = tmp;
         == flag){
            return true;
        }
        if(Is_Equal(initial, partial, size)){
            flag = ;
        }
    }

    return false;
}

void New_Merge_Sort(int initial[], int partial[], int size){
    int i, j, flag = false;

    ; i &lt; size; i *= ){
        ; j &lt; size; j += i * ){
             &lt; size)
                qsort(initial + j, i * , sizeof(int), comp);
            else if(size - j &gt; i){
                qsort(initial + j, size - j, sizeof(int), comp);
            }
        }
        if(flag){
            break;
        }
        if(Is_Equal(initial, partial, size)){
            flag = true;
        }
    }
}

int main(){
    int N;
    int initial[MAX], partial[MAX], tmp[MAX];

    Init(initial, tmp, partial, &amp;N);
    if(!Is_Insertion_Sort(initial, partial, N)){
        New_Merge_Sort(tmp, partial, N);
        printf("Merge Sort\n");
        Output(tmp, N);
    }
    else{
        printf("Insertion Sort\n");
        Output(initial, N);
    }
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o5l159.html">Ajax&amp;amp&semi;Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22j3vq.html">Java命名规则总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rlwl49.html">解决 Virtual Box 启动 Cannot load R0 module supLoadModule returned VERR&lowbar;LDR&lowbar;MISMATCH&lowbar;NATIVE Failed to register ourselves as a PCI Bus &lpar;VERR&lowbar;MODULE&lowbar;NOT&lowbar;FOUND&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm171z9.html">Callable&comma; Runnable&comma; Future&comma; FutureTask</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdl0gy8.html">502 bad gateway 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vejr48.html">如何使用NSOperations和NSOperationQueues（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnlejq.html">IOS  UItableView 滚动到底 触发事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzp5v8.html">JavaScript基础笔记二</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zp6j9.html">&lbrack;LeetCode&num;128&rsqb;Word Ladder II</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxpym8.html">osg</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwn3l8.html">JAVA NIO 选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yn1rg8.html">数据库DML操作（DCL了解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxvje9.html">Angular相关命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj2e5z8.html">access数据库转sql server中ID的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljgvox9.html">SpringMvc 请求中日期类型参数接收一二事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1n3g1q.html">python webdriver api-对启动的火狐浏览器添加配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydl32q.html">&lbrack;随笔&rsqb;&lbrack;Java&rsqb;&lbrack;something&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn1xk8.html">babel在项目里的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rgvoo9.html">Java获取系统时间的四种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlld5r9.html">Docker 入门（Mac环境）-part 1  入门基本操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jlz1eq.html">matlab的滤波器仿真&mdash;&mdash;低通滤波器与插值滤波器</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlvj5x9.html">BASH 漏洞修复</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gged79.html">poi导出excel通用类</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7gm48.html">Wireshark简易教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxydwv9.html">adcfgclone&period;pl appsTier报错Unable to locate &amp;&num;39&semi;linkxlC&amp;&num;39&semi; utility in path</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq14pw5q.html">bootstrapValidator&period;js，最好用的bootstrap表单验证插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/495dj3eq.html">MYSQL性能优化分享&lpar;分库分表&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7dnreq.html">FPS中受伤UI在VR游戏中的实现思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mkpg6q.html">在js中怎么样选择互斥的相邻元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwwnzzq.html">EM算法（2）：GMM训练算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
